REBOL [
author: "Shadwolf"
date: "02/07/08"
Purpose: {
This is a Berlin Clock.

The goal of this clock is to provide a universal way to 
read a clock 

How to read the Berlin Clock:
from top to bottom 

On first row each block represents 5 hours
On second row each block represents 1 hour
on third row each block represents 5 minutes
on  fourth row each bblock represents 1 minute
the blinking central circle led represent the seconds
}

]


a: 1 
prev-H5:  prev-H1: prev-M5: prev-M1: none

view  layout  [
space 0x0
at 0x0
H5-1: image %H5btn.png
H1-1: image %H1btn1-2.png
M5-1: image %M5btn1-1.png
M5-2: image %M5btn1-1.png
at 14x47
M5-3: image %M5btn2-1.png
M5-4: image %M5btn1-1.png
at 0x81
M1-1: image %H5btn.png

at 31x0
H5-2: image %H5btn.png
H1-2: image %H1btn2-2.png
M5-5: image %M5btn4-1.png
M1-2: image %H5btn.png

at 62x0
H5-3: image %H5btn.png
H1-3: image %H1btn3-2.png
at 70x47
M5-7: image %M5btn5-1.png
at 62x81
M1-3: image %H5btn.png

at 93x0
H5-4: image %H5btn.png
H1-4: image %H1btn1-2.png
M5-8: image %M5btn1-1.png
M5-9: image %M5btn2-1.png
at 107x47
M5-10: image %M5btn1-1.png
M5-11: image %M5btn1-1.png
at 93x81
M1-4: image %H5btn.png

; minutes central image
at 52x70
M5-6: image %M5btn3-1.png

;seconds image
at  36x24
S1: image %Sbtn1.png
at 0x100
btn "QUIT !!" [ quit ]
; Action code ^^
	rate 1 feel  [
		engage: func [face act evt] [
			if act = 'time [
			cur-time: to-string now/time
	cur-time: parse cur-time ":"
    ;hours x5 line calculation
    H5-line: round/down ( to-integer cur-time/1 ) / 5 
    if (H5-line <> prev-H5) [
    	if ( H5-line = 0 ) [ H5-1/image: H5-2/image: H5-3/image: H5-4/image: load %H5btn.png ]
    	if ( H5-line = 1 ) or ( 1  < H5-line ) [ H5-1/image: load %H5btn2.png ]
    	if ( H5-line = 2 ) or ( 2  < H5-line ) [ H5-2/image: load %H5btn2.png ]
    	if ( H5-line = 3 ) or ( 3  < H5-line ) [ H5-3/image: load %H5btn2.png ]
    	if ( H5-line = 4 ) [ H5-4/image: load %H5btn2.png ]
    	show [ H5-1 H5-2 H5-3 H5-4 ]
   		prev-H5: H5-line
	]
    ;hour x1 line calculation
    H1-line: mod  ( to-integer cur-time/1 ) 5
    if (H1-line <> prev-H1) [
    	if ( H1-line = 0 ) [ H1-1/image: H1-4/image: load %H1btn1-2.png  H1-2/image: load %H1btn2-2.png  H1-3/image: load %H1btn3-2.png  ]
    	if ( H1-line = 1 ) or ( 1  < H1-line ) [ H1-1/image: load %H1btn1-1.png ]
    	if ( H1-line = 2 ) or ( 2  < H1-line ) [ H1-2/image: load %H1btn2-1.png ]
    	if ( H1-line = 3 ) or ( 3  < H1-line ) [ H1-3/image: load %H1btn3-1.png ]
    	if ( H1-line = 4 ) [ H1-4/image: load %H1btn1-1.png  ]
    	show [ H1-1 H1-2 H1-3 H1-4 ]
		prev-H1: H1-line
    ]
    ;minutes x5 line calculation
    M5-line: round/down ( to-integer cur-time/2 ) / 5 
    if M5-line <> prev-M5 [
    	if (M5-line = 0) [ M5-1/image:  M5-2/image: M5-4/image: M5-8/image: M5-10/image: M5-11/image: load %M5btn1-1.png M5-3/image: M5-9/image: load %M5btn2-1.png M5-5/image: load %M5btn4-1.png M5-6/image: load %M5btn3-1.png M5-7/image: load %M5btn5-1.png ]
    	if (M5-line = 1) or ( 1 < M5-line ) [ M5-1/image: load %M5btn1-2.png ]
    	if (M5-line = 2) or ( 2 < M5-line ) [ M5-2/image: load %M5btn1-2.png ]
    	if (M5-line = 3) or ( 3 < M5-line ) [ M5-3/image: load %M5btn2-2.png ]
    	if (M5-line = 4) or ( 4 < M5-line ) [ M5-4/image: load %M5btn1-2.png ]
    	if (M5-line = 5) or ( 5 < M5-line ) [ M5-5/image: load %M5btn4-2.png ]
    	if (M5-line = 6) or ( 6 < M5-line ) [ M5-6/image: load %M5btn3-2.png ]
    	if (M5-line = 7) or ( 7 < M5-line ) [ M5-7/image: load %M5btn5-2.png ]
    	if (M5-line = 8) or ( 8 < M5-line ) [ M5-8/image: load %M5btn1-2.png ]
    	if (M5-line = 9) or ( 9 < M5-line ) [ M5-9/image: load %M5btn2-2.png ]
    	if (M5-line = 10) or ( 10 < M5-line ) [ M5-10/image: load %M5btn1-2.png ]
    	if (M5-line = 11) [ M5-11/image: load %M5btn1-2.png ]
    	show [ M5-1 M5-2 M5-3 M5-4 M5-5 M5-6 M5-7 M5-8 M5-9 M5-10 M5-11 ]
		prev-M5: M5-line
    ]
    ;minutes x1 lines calculation
    M1-line: mod  ( to-integer cur-time/2 ) 5
    if prev-M1 <> M1-line [
    	if (M1-line = 0) [ M1-1/image:  M1-2/image: M1-3/image: M1-4/image: load %H5btn.png ]
    	if (M1-line = 1) or ( 1 < M1-line ) [ M1-1/image: load %H5btn2.png]
    	if (M1-line = 2) or ( 2 < M1-line ) [ M1-2/image: load %H5btn2.png]
    	if (M1-line = 3) or ( 3 < M1-line ) [ M1-3/image: load %H5btn2.png ]
    	if (M1-line = 4) [ M1-4/image: load %H5btn2.png ]
    	show [ M1-1 M1-2 M1-3 M1-4 ]
    	prev-M1: M1-line
	]
    ; seconds animation 
    either a = 1 
    [ a: 2 S1/image: load %Sbtn1.png ]
	[ a: 1 S1/image: load %Sbtn2.png ]
	show S1
		]
	  ]
	]
]

